// EIKCONCL.H
//
// Copyright (c) 1997-1999 Symbian Ltd.  All rights reserved.
//

#if !defined(__EIKCONCL_H__)
#define __EIKCONCL_H__

#if !defined(__E32CONS_H__)
#include <e32cons.h>
#endif

#if !defined(__W32STD_H__)
#include <w32std.h>
#endif
#if !defined(__EIKCONSO_H__)
#include <eikconso.h>
#endif

class CMyConsoleScreen;
class CAdvConsoleClient;

CAdvConsoleClient *NewAdvConsole(const TDesC *aFaceName);

typedef const TAny* CATP;

// Mouse events are simulated through the console client as character 255 with the mouse position
// readable separately.
#define EKeyPointer 255

class CAdvConsoleClient : public CConsoleBase
	{
public:
	~CAdvConsoleClient();
public: // from CConsoleBase
    virtual void Color(TUint aForegroundGrey16,TUint aBackgroundGrey16);
    virtual void SetAttr(int attrib);
    void Read(TRequestStatus& aStatus);
    void ReadCancel();
    void Write(const TDesC& aDes);
    TPoint CursorPos() const;
    void SetCursorPosAbs(const TPoint& aPoint);
    void SetCursorPosRel(const TPoint& aPoint);
    void SetCursorHeight(TInt aPercentage);
    void SetTitle(const TDesC& aTitle);
    void ClearScreen();
    void ClearToEndOfLine();
    TSize ScreenSize() const;
    TKeyCode KeyCode() const;
    TUint KeyModifiers() const;
    virtual int KeyHit();
    void SetFont(TDesC *aFaceName, TInt aPointSize);
    TPoint PointerPos();      // Last known pointer position.
    
private:
	friend CAdvConsoleClient* NewAdvConsole(const TDesC *aFaceName);
	CAdvConsoleClient(const TDesC *aFaceName);
private: // from CConsoleBase
	TInt Create(const TDesC& aTitle,TSize aSize);
private: // internal use only
	void SendReceive(TInt aMessage,const TAny* aParam);
	inline void SendReceive(TInt aMessage,TInt aParam) { SendReceive(aMessage,(const TAny*)aParam); }
private:
	friend class CAdvConsMessager;
	RThread iThread;
	TRequestStatus iLogonStatus;
	TRequestStatus* iThreadStatus;
	TInt* iMessage;
	CATP* iParam;
	TRequestStatus** iReplyStatus;
	TKeyEvent iKeyEvent;
	CMyConsoleScreen* iScreen;
	TBuf<20> iFaceName;
	TInt iTwipSize;
	};

#endif
