/*
 * This file is the equivalent of pctty.c, wintty.c etc.
 */
#include "hack.h"
#include "wintty.h"
#include "mytty.h"
#include <stdarg.h>

char erase_char = '\b', kill_char = 21;		/* cntl-U */


/* reset terminal to original state */
void settty(const char *s)
{
    end_screen();
    if(s) raw_print(s);
}

/* called by init_nhwindows() and resume_nhwindows() */
void setftty()
{
	start_screen();
}

#if 0
/*
 *  Keyboard translation tables.
 *  (Adopted from the MSDOS port)
 */

#define KEYPADLO	0x47
#define KEYPADHI	0x53

#define PADKEYS 	(KEYPADHI - KEYPADLO + 1)
#define iskeypad(x)	(KEYPADLO <= (x) && (x) <= KEYPADHI)

/*
 * Keypad keys are translated to the normal values below.
 * Shifted keypad keys are translated to the
 *    shift values below.
 */

static const struct pad {
	uchar normal, shift, cntrl;
} keypad[PADKEYS] = {
			{'y', 'Y', C('y')},		/* 7 */
			{'k', 'K', C('k')},		/* 8 */
			{'u', 'U', C('u')},		/* 9 */
			{'m', C('p'), C('p')},		/* - */
			{'h', 'H', C('h')},		/* 4 */
			{'g', 'g', 'g'},		/* 5 */
			{'l', 'L', C('l')},		/* 6 */
			{'p', 'P', C('p')},		/* + */
			{'b', 'B', C('b')},		/* 1 */
			{'j', 'J', C('j')},		/* 2 */
			{'n', 'N', C('n')},		/* 3 */
			{'i', 'I', C('i')},		/* Ins */
			{'.', ':', ':'}			/* Del */
}, numpad[PADKEYS] = {
			{'7', M('7'), '7'},		/* 7 */
			{'8', M('8'), '8'},		/* 8 */
			{'9', M('9'), '9'},		/* 9 */
			{'m', C('p'), C('p')},		/* - */
			{'4', M('4'), '4'},		/* 4 */
			{'g', 'G', 'g'},		/* 5 */
			{'6', M('6'), '6'},		/* 6 */
			{'p', 'P', C('p')},		/* + */
			{'1', M('1'), '1'},		/* 1 */
			{'2', M('2'), '2'},		/* 2 */
			{'3', M('3'), '3'},		/* 3 */
			{'i', 'I', C('i')},		/* Ins */
			{'.', ':', ':'}			/* Del */
};
#endif

/* fatal error */
/*VARARGS1*/

void
error (const char *s, ...)
{
    //VA_DECL(const char *,s)
    va_list the_args;
    va_start(the_args, s); // VA_START(s);
    // VA_INIT(s, const char *);
    /* error() may get called before tty is initialized */
    if (iflags.window_inited) end_screen();
    xputc('\n');
    vprintf(s,the_args);
    xputc('\n');
    va_end(the_args); //VA_END();
    exit(EXIT_FAILURE);
}


void
tty_startup(wid, hgt)
    int *wid, *hgt;
{
    get_scr_size();
#if defined(CLIPPING)
    if(CO < COLNO || LI < ROWNO+3) {
        setclipped();
    }
#endif
    *wid = CO;
    *hgt = LI;
}

void
tty_number_pad(state)
int state;
{
}

void
tty_start_screen()
{
	if (iflags.num_pad) tty_number_pad(1);	/* make keypad send digits */
}

void
tty_end_screen()
{
	clear_screen();
}


